Description

Flow has the notion of ApplicationContext which provides a unique API for handling contexts.

Having this APl in TYPO3 CMS would allow us to provide default configuration sets for partic
decent logging in production context vs. full reports in development context.

ular contexts. For example having

Extension developers would also benefit from streamlining their custom solutions to a single API.

The context is set using the TYPO3_CONTEXT environment variable.

Here's an example of how to set this variable in apache htaccess:

RewriteCond %{HTTP_HOST} dev\.example\.com$
RewriteRule (.*) $1 [E=TYPO3_CONTEXT:Development]

RewriteCond %{HTTP_HOST} "www\.example\.com$
RewriteRule (.*) $1 [E=TYPO3_CONTEXT:Production]

The particular context can be obtained in the following way:
\TYPO3\CMS\Core\Core\Bootstrap::getinstance()->getContext()
# shorthand to predefined contexts:

\TYPO3\CMS\Core\Core\Bootstrap::getinstance()->getContext()->isDevelopment();
\TYPO3\CMS\Core\Core\Bootstrap::getinstance()->getContext()->isProduction();

Subtasks:
Feature # 50131: Load context specific configuration files Closed
Feature # 50132: TypoScript: Application Context condition Resolved
Bug # 50983: Add public API to get ApplicationContext Resolved
Related issues:
related to Core - Feature # 39441: Add TYPOS3 Context information Closed 2012-08-01
related to Core APls - Feature # 50174: Add new chapter about ApplicationContext Resolved 2013-07-18
related to Core - Task # 49953: Disable DeprecationLog by default Closed 2013-07-11
Associated revisions
Flow has the notion of ApplicationContext which provides a unique

API for handling contexts.

This API allow us to provide default configuration sets for
particular contexts. For example having decent logging in
production context vs. full reports in development context.

The context is set using the TYPO3_CONTEXT environment variable.
If not set the context defaults to "Production”.

The context can be queried using:
\TYPO3\CMS\Core\Core\Bootstrap::getinstance()->getContext();

Resolves: #49988

Releases: 6.2

Change-Id: 10953052f2846¢740f27a83931adfb64b0d8d9169
Reviewed-on: https://review.typo3.org/22269

Reviewed-by: Thomas Maroschik
Reviewed-by: Stefan Neufeind
Tested-by: Stefan Neufeind

History

#1 - 2013-07-12 20:59 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/22269

#2 - 2013-07-12 21:08 - Steffen Miiller

Find this blog article by Matthias Witte about TYPO3 FLOW contexts.

#3 - 2013-07-15 14:40 - Fabien Udriot

Quoting Christian Kuhn from http://forge.typo3.org/issues/39441#note-2

Imho FLOW has a way better concept at this point: It has an object for context and subcontexts, they can be extended and new subcontexts can
be added. This is the way to go for us, too. | think, Thomas is working on a similar thing in his sandbox and has something at hand already.

| don't really know the "subcontexts" of Flow... It looks it is mentioned in the Flow documentation. Wondering if we are able of such things...

#4 - 2013-07-15 16:03 - Steffen Miiller

Yes, subcontexts are part of Flow and also part of the backport. See line 79 of ApplicationContext.php

We'd have static contexts "Production”, "Development" and "Testing" and custom subcontexts, like Production/Staging, "Development/Debug",

"Testing/Unit" etc.
So the root context is not extendable, but the subcontexts are.

The whole backport is 1:1 from Flow, so the Flow documentation would also be valid for us.

#5 - 2013-07-16 20:22 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/22269

#6 - 2013-07-16 20:41 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/22269

#7 - 2013-07-16 20:48 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/22269

#8 - 2013-07-16 20:50 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/22269

#9 - 2013-07-17 11:17 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/22269

#10 - 2013-07-17 11:30 - Steffen Miiller
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset commit:8fdab46dbd167b1969dcb30b823f3f3e591d03a2.

#11 - 2013-07-17 12:31 - Mathias Brodala

Why was this marked as resolved already? The configuration part is still missing and needs work in the core ConfigurationManager AFAIS since that's
what Flow does.

#12 - 2013-07-17 12:35 - Stefan Neufeind

It was set Resolved by gerrit since the patch was merged.

Imho this was about the "core" of it (ApplicationContext). What other changes we'll have now depending on the current context are imho follow-ups to
this. Maybe file separate issues and link them here.

Thanks for caring.

#13 - 2013-07-17 12:37 - Mathias Brodala
Stefan Neufeind wrote:
It was set Resolved by gerrit since the patch was merged.

Imho this was about the "core" of it (ApplicationContext). What other changes we'll have now depending on the current context are imho follow-ups
to this. Maybe file separate issues and link them here.

OK, got it. Thanks for clarifying. :-)

#14 - 2013-07-17 20:17 - Ingo Renner

just extracted two issues from #39441 - see the linked sub tasks
